Index: src/main/java/com/xpn/xwiki/api/DocumentAction.java
===================================================================
--- src/main/java/com/xpn/xwiki/api/DocumentAction.java	(revision 0)
+++ src/main/java/com/xpn/xwiki/api/DocumentAction.java	(revision 0)
@@ -0,0 +1,510 @@
+/*
+ * Copyright 2004-2007, XpertNet SARL, and individual contributors.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ *
+ *
+ * This distribution includes the following modules:
+ *
+ * http://jakarta.apache.org: velocity, struts, jrcs, commons, etc..
+ * This distribution also includes libraries from the Apache Software
+ * Foundation distributed under the terms of the Apache Software License.
+ * See http://www.opensource.org/licenses/apachepl.php
+ *
+ * http://www.hibernate.org:
+ * This distribution includes libraries from hibernate.org distributed
+ * under the terms of the Lesser General Public License.
+ * See http://www.gnu.org/copyleft/lesser.html
+ *
+ * http://www.junit.org
+ * This distribution includes libraries from junit.org distributed 
+ * under the terms of the Common Public License
+ * See http://www.opensource.org/licenses/cpl.php
+ *
+ * ===================================================================
+ */
+package com.xpn.xwiki.api;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+
+/**
+ * Actions for the documents, to be used instead of string values like "view", "download", etc.
+ * The names of the constants are exactly the names of the actions in the upper-case. E.g. for the 
+ * "view" action, the corresponding constant is DocumentAction.VIEW. An exception to this rule is 
+ * the {@link DocumentAction#NONE} constant, associated to an empty action string, "".
+ * <br />
+ * <strong>NOTE:</strong> the string value of the action, stored by an instance of this class, is 
+ * always trimmed and lowercased. So the tests performed by {@link DocumentAction#valueOf(String)}, 
+ * {@link DocumentAction#isActionDefined(String)}, etc. are case insensitive. 
+ * 
+ * @author Anca-Paula Luca
+ */
+public class DocumentAction
+{
+    public static final DocumentAction LOGIN = new DocumentAction("login");
+    public static final DocumentAction LOGOUT = new DocumentAction("logout");
+    public static final DocumentAction LOGINERROR = new DocumentAction("loginerror");
+    public static final DocumentAction LOGINSUBMIT = new DocumentAction("loginsubmit");
+    public static final DocumentAction VIEW = new DocumentAction("view");
+    public static final DocumentAction VIEWREV = new DocumentAction("viewrev");
+    public static final DocumentAction DOWNLOADREV = new DocumentAction("downloadrev");
+    
+    //this action is used in this class, but it appears in the struts-config.xml file, 
+    //the view action
+    public static final DocumentAction PLAIN = new DocumentAction("plain");
+    
+    public static final DocumentAction ATTACH = new DocumentAction("attach");
+    public static final DocumentAction SKIN = new DocumentAction("skin");
+    public static final DocumentAction DOWNLOAD = new DocumentAction("download");
+    
+    //DOT and SVG are not a constants because they are plugin actions
+    //public static final DocumentAction DOT = new DocumentAction("dot");
+    //public static final DocumentAction SVG = new DocumentAction("svg");
+    
+    public static final DocumentAction PDF = new DocumentAction("pdf");
+    
+    public static final DocumentAction DELETE = new DocumentAction("delete");
+    public static final DocumentAction RESET = new DocumentAction("reset");
+    public static final DocumentAction REDIRECT = new DocumentAction("redirect");
+    public static final DocumentAction UNKNOWN = new DocumentAction("unknown");
+    
+    public static final DocumentAction COMMENTADD = new DocumentAction("commentadd");
+    public static final DocumentAction REGISTER = new DocumentAction("register");
+    public static final DocumentAction ADMIN = new DocumentAction("admin");
+    public static final DocumentAction EXPORT = new DocumentAction("export");
+    public static final DocumentAction IMPORT = new DocumentAction("import");
+    
+    public static final DocumentAction EDIT = new DocumentAction("edit");
+    public static final DocumentAction INLINE = new DocumentAction("inline");
+    
+    public static final DocumentAction SAVE = new DocumentAction("save");
+        
+    public static final DocumentAction PREVIEW = new DocumentAction("preview");
+    public static final DocumentAction VIEWATTACHREV = new DocumentAction("viewattachrev");
+    
+    public static final DocumentAction LOCK = new DocumentAction("lock");
+    public static final DocumentAction CANCEL = new DocumentAction("cancel");
+    public static final DocumentAction ROLLBACK = new DocumentAction("rollback");
+    public static final DocumentAction OBJECTADD = new DocumentAction("objectadd");
+    public static final DocumentAction OBJECTREMOVE = new DocumentAction("objectremove");
+    public static final DocumentAction PROPADD = new DocumentAction("propadd");
+    public static final DocumentAction PROPUPDATE = new DocumentAction("propupdate");
+    public static final DocumentAction UPLOAD = new DocumentAction("upload");
+    public static final DocumentAction DELATTACHMENT = new DocumentAction("delattachment");
+    
+    public static final DocumentAction PROPDELETE = new DocumentAction("propdelete");
+    public static final DocumentAction EDITPREFS = new DocumentAction("editprefs");
+    
+    //this constant matches no action, that is, an empty string "". Don't mistake it for  
+    //a "none" action or something.
+    public static final DocumentAction NONE = new DocumentAction(""); 
+        
+    /**
+     * holds all constants defined in this class.
+     */
+    private static ArrayList values;
+    
+    /**
+     * The string value corresponding to this DocumentAction instance.
+     */
+    private String action;
+        
+    private static HashMap actionRightMap;
+    
+    //initialization block for actionRightMap
+    static 
+    {
+        DocumentAction.actionRightMap = new HashMap();
+        DocumentAction.actionRightMap.put(DocumentAction.LOGIN, AccessLevel.LOGIN);
+        DocumentAction.actionRightMap.put(DocumentAction.LOGOUT, AccessLevel.LOGIN);
+        DocumentAction.actionRightMap.put(DocumentAction.LOGINERROR, AccessLevel.LOGIN);
+        DocumentAction.actionRightMap.put(DocumentAction.LOGINSUBMIT, AccessLevel.LOGIN);
+        DocumentAction.actionRightMap.put(DocumentAction.VIEW, AccessLevel.VIEW);
+        DocumentAction.actionRightMap.put(DocumentAction.VIEWREV, AccessLevel.VIEW);
+        DocumentAction.actionRightMap.put(DocumentAction.DOWNLOADREV, AccessLevel.DOWNLOAD);
+        DocumentAction.actionRightMap.put(DocumentAction.PLAIN, AccessLevel.VIEW);
+        DocumentAction.actionRightMap.put(DocumentAction.ATTACH, AccessLevel.VIEW);
+        DocumentAction.actionRightMap.put(DocumentAction.SKIN, AccessLevel.VIEW);
+        DocumentAction.actionRightMap.put(DocumentAction.DOWNLOAD, AccessLevel.VIEW);
+        DocumentAction.actionRightMap.put(DocumentAction.PDF, AccessLevel.VIEW);
+        DocumentAction.actionRightMap.put(DocumentAction.DELETE, AccessLevel.DELETE);
+        DocumentAction.actionRightMap.put(DocumentAction.RESET, AccessLevel.DELETE);
+        DocumentAction.actionRightMap.put(DocumentAction.COMMENTADD, AccessLevel.COMMENT);
+        DocumentAction.actionRightMap.put(DocumentAction.REGISTER, AccessLevel.REGISTER);
+        DocumentAction.actionRightMap.put(DocumentAction.REDIRECT, AccessLevel.VIEW);
+        DocumentAction.actionRightMap.put(DocumentAction.ADMIN, AccessLevel.ADMIN);
+        DocumentAction.actionRightMap.put(DocumentAction.EXPORT, AccessLevel.VIEW);
+        DocumentAction.actionRightMap.put(DocumentAction.IMPORT, AccessLevel.ADMIN);
+        DocumentAction.actionRightMap.put(DocumentAction.UNKNOWN, AccessLevel.VIEW);        
+    }
+    
+
+    /**
+     * Builds the DocumentAction from the string value. The value is trimmed as well as transformed 
+     * to lower case.
+     * TODO: Should be uppercased for compatibility with the 5.0 enum type.
+     * 
+     * @param action The {@link String} value of the document action.
+     */
+    private DocumentAction(String action)
+    {
+        //trim it, lowercase it
+        this.action = action.trim().toLowerCase();
+        //add this to the values array
+        if (DocumentAction.values == null) {
+            DocumentAction.values = new ArrayList();
+        }
+        DocumentAction.values.add(this);
+    }
+    
+    /**
+     * @return the list of all DocumentAction constants.
+     */
+    public static DocumentAction[] values() {
+        DocumentAction[] returnArray = new DocumentAction[DocumentAction.values.size()]; 
+        DocumentAction.values.toArray(returnArray);
+        return returnArray;
+    }
+    
+    /**
+     * Provides the right for a specified action, according to the rights map hold by this class. 
+     * If the action is not found in the rights map hold by this class, the default right, 
+     * {@link AccessLevel#EDIT} is returned.
+     * 
+     * @param action the action to provide the right for
+     * @return the right
+     */
+    public static AccessLevel getAccessLevel(DocumentAction action) {
+        AccessLevel rightFound = (AccessLevel)DocumentAction.actionRightMap.get(action);
+        if (rightFound == null) {
+            rightFound = AccessLevel.EDIT;
+        }
+        
+        return rightFound;
+    }
+    
+    public AccessLevel getAccessLevel() {
+        return DocumentAction.getAccessLevel(this);
+    }
+
+    /**
+     * @return the action
+     */
+    public String getAction()
+    {
+        return action;
+    }
+
+    /**
+     * Returns the DocumentAction constant correspnding to the given actionString, testing equality 
+     * with the trimmed, lowercased value of the actionString. If no match is found, a new 
+     * <tt>DocumentAction</tt> is built and added to the list of actions.
+     * 
+     * @param actionString the string value of the action
+     * @return the DocumentAction constant that matches the string value
+     */
+    public static DocumentAction valueOf(String actionString)
+    {
+        String cleanActionString = actionString.trim().toLowerCase();
+        DocumentAction[] constants = DocumentAction.values();
+        for (int i = 0; i < constants.length; i++) {
+            if (constants[i].getAction().equals(cleanActionString)) {
+                //found, return it
+                return constants[i];
+            }
+        }
+        //if it wasn't found, it's a new action.
+        DocumentAction newAction = new DocumentAction(actionString);
+        //put it in the values array
+        DocumentAction.values.add(newAction);
+        return newAction;
+    }
+    
+    /**
+     * Returns the action matching to actionString (as {@link DocumentAction#valueOf(String)} does),
+     * only that, when creating the action, it also associates it with <tt>right</tt>. If the action
+     * has been previously defined, no changes are made on it's rights. If you want 
+     * to create an action and set the access right for it, you must use this function.
+     * 
+     * TODO: find a better, more intuitive name for this function. 
+     * 
+     * @param actionString the string value of the action.
+     * @param right the right to associate to the action, if it is a newly created action.
+     * @return the DocumentAction that matches the <tt>actionString</tt>
+     * @see DocumentAction#valueOf(String)
+     */
+    public static DocumentAction valueOf(String actionString, AccessLevel right) {
+        boolean actionDefined = DocumentAction.isActionDefined(actionString);
+        //get the action
+        DocumentAction theAction = DocumentAction.valueOf(actionString);
+        if (!actionDefined) {
+            //if it wasn't defined before this, associate the right
+            DocumentAction.actionRightMap.put(theAction, right);
+        }
+        
+        return theAction;
+    }
+    
+    /**
+     * Tests whether a DocumentAction is defined for the provided action string, trimmed and 
+     * lowercased.
+     * 
+     * @param actionString the string value of the action.
+     * @return true if an action with a matching string value was found and false otherwise. 
+     */
+    public static boolean isActionDefined(String actionString) {
+        String cleanActionString = actionString.trim().toLowerCase();
+        DocumentAction[] constants = DocumentAction.values();
+        for (int i = 0; i < constants.length; i++) {
+            if (constants[i].getAction().equals(cleanActionString)) {
+                return true;
+            }
+        }
+        return false;
+    }
+
+    /**
+     * {@inheritDoc}
+     * 
+     * @see Object#equals
+     */
+    public boolean equals(java.lang.Object obj)
+    {
+        //arrrrgh com.xpn.xwiki.api.Object...
+        if ((obj != null) && (obj instanceof DocumentAction)) {
+            DocumentAction documentAction = (DocumentAction) obj;
+            if (documentAction == this) {
+                return true;
+            } else {
+                return false;
+            }
+        } else {
+            return false;
+        }
+        
+    }
+
+    /**
+     * {@inheritDoc}
+     * 
+     * @see Object#hashCode
+     */
+    public int hashCode()
+    {
+        return this.action.hashCode();
+    }
+
+    /**
+     * {@inheritDoc}
+     * 
+     * @see Object#toString
+     */
+    public String toString()
+    {
+        return this.action;
+    }
+
+    public static DocumentAction getADMIN()
+    {
+        return ADMIN;
+    }
+
+    public static DocumentAction getATTACH()
+    {
+        return ATTACH;
+    }
+
+    public static DocumentAction getCANCEL()
+    {
+        return CANCEL;
+    }
+
+    public static DocumentAction getCOMMENTADD()
+    {
+        return COMMENTADD;
+    }
+
+    public static DocumentAction getDELATTACHMENT()
+    {
+        return DELATTACHMENT;
+    }
+
+    public static DocumentAction getDELETE()
+    {
+        return DELETE;
+    }
+
+    public static DocumentAction getDOWNLOAD()
+    {
+        return DOWNLOAD;
+    }
+
+    public static DocumentAction getDOWNLOADREV()
+    {
+        return DOWNLOADREV;
+    }
+
+    public static DocumentAction getEDIT()
+    {
+        return EDIT;
+    }
+
+    public static DocumentAction getEDITPREFS()
+    {
+        return EDITPREFS;
+    }
+
+    public static DocumentAction getEXPORT()
+    {
+        return EXPORT;
+    }
+
+    public static DocumentAction getIMPORT()
+    {
+        return IMPORT;
+    }
+
+    public static DocumentAction getINLINE()
+    {
+        return INLINE;
+    }
+
+    public static DocumentAction getLOCK()
+    {
+        return LOCK;
+    }
+
+    public static DocumentAction getLOGIN()
+    {
+        return LOGIN;
+    }
+
+    public static DocumentAction getLOGINERROR()
+    {
+        return LOGINERROR;
+    }
+
+    public static DocumentAction getLOGINSUBMIT()
+    {
+        return LOGINSUBMIT;
+    }
+
+    public static DocumentAction getLOGOUT()
+    {
+        return LOGOUT;
+    }
+
+    public static DocumentAction getNONE()
+    {
+        return NONE;
+    }
+
+    public static DocumentAction getOBJECTADD()
+    {
+        return OBJECTADD;
+    }
+
+    public static DocumentAction getOBJECTREMOVE()
+    {
+        return OBJECTREMOVE;
+    }
+
+    public static DocumentAction getPDF()
+    {
+        return PDF;
+    }
+
+    public static DocumentAction getPLAIN()
+    {
+        return PLAIN;
+    }
+
+    public static DocumentAction getPREVIEW()
+    {
+        return PREVIEW;
+    }
+
+    public static DocumentAction getPROPADD()
+    {
+        return PROPADD;
+    }
+
+    public static DocumentAction getPROPDELETE()
+    {
+        return PROPDELETE;
+    }
+
+    public static DocumentAction getPROPUPDATE()
+    {
+        return PROPUPDATE;
+    }
+
+    public static DocumentAction getREDIRECT()
+    {
+        return REDIRECT;
+    }
+
+    public static DocumentAction getREGISTER()
+    {
+        return REGISTER;
+    }
+
+    public static DocumentAction getRESET()
+    {
+        return RESET;
+    }
+
+    public static DocumentAction getROLLBACK()
+    {
+        return ROLLBACK;
+    }
+
+    public static DocumentAction getSAVE()
+    {
+        return SAVE;
+    }
+
+    public static DocumentAction getSKIN()
+    {
+        return SKIN;
+    }
+
+    public static DocumentAction getUNKNOWN()
+    {
+        return UNKNOWN;
+    }
+
+    public static DocumentAction getUPLOAD()
+    {
+        return UPLOAD;
+    }
+
+    public static DocumentAction getVIEW()
+    {
+        return VIEW;
+    }
+
+    public static DocumentAction getVIEWATTACHREV()
+    {
+        return VIEWATTACHREV;
+    }
+
+    public static DocumentAction getVIEWREV()
+    {
+        return VIEWREV;
+    }
+}
Index: src/main/java/com/xpn/xwiki/api/Document.java
===================================================================
--- src/main/java/com/xpn/xwiki/api/Document.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/api/Document.java	(working copy)
@@ -391,29 +391,50 @@
      */
     public String getAttachmentURL(String filename)
     {
-        return doc.getAttachmentURL(filename, "download", getXWikiContext());
+        return doc.getAttachmentURL(filename, DocumentAction.DOWNLOAD, getXWikiContext());
     }
 
+
     /**
+     * @see Document#getAttachmentURL(String, DocumentAction)
+     * @deprecated use {@link Document#getAttachmentURL(String, DocumentAction)}
+     */
+    public String getAttachmentURL(String filename, String action)
+    {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getAttachmentURL(filename, documentAction);
+    }
+    
+    /**
      * return the URL of the given action for the  the given attachment name
      *
      * @return A string with the URL
      */
-    public String getAttachmentURL(String filename, String action)
+    public String getAttachmentURL(String filename, DocumentAction action)
     {
         return doc.getAttachmentURL(filename, action, getXWikiContext());
     }
 
     /**
+     * @see Document#getAttachmentURL(String, DocumentAction, String)
+     * @deprecated use {@link Document#getAttachmentURL(String, DocumentAction, String)}
+     */
+    public String getAttachmentURL(String filename, String action, String queryString)
+    {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getAttachmentURL(filename, documentAction, queryString);
+    }
+    
+    /**
      * return the URL of the given action for the  the given attachment name with "queryString"
      * parameters
      *
      * @param queryString parameters added to the URL
      */
-    public String getAttachmentURL(String filename, String action, String queryString)
+    public String getAttachmentURL(String filename, DocumentAction action, String queryString)
     {
         return doc.getAttachmentURL(filename, action, queryString, getXWikiContext());
-    }
+    }    
 
     /**
      * return the URL for accessing to the archive of the attachment "filename" at the version
@@ -438,45 +459,84 @@
      */
     public String getURL()
     {
-        return doc.getURL("view", getXWikiContext());
+        return doc.getURL(DocumentAction.VIEW, getXWikiContext());
     }
 
     /**
      * return the URL of this document with the given action
      */
-    public String getURL(String action)
+    public String getURL(DocumentAction action)
     {
         return doc.getURL(action, getXWikiContext());
     }
-
+    
     /**
+     *  @see Document#getURL(DocumentAction)
+     *  @deprecated use {@link Document#getURL(DocumentAction)} 
+     */
+    public String getURL(String action)
+    {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getURL(documentAction);
+    }
+    
+    /**
      * return the URL of this document with the given action and queryString as parameters
      */
-    public String getURL(String action, String querystring)
+    public String getURL(DocumentAction action, String querystring)
     {
         return doc.getURL(action, querystring, getXWikiContext());
     }
+    
+    /**
+     * @see Document#getURL(DocumentAction, String)
+     * @deprecated use {@link Document#getURL(DocumentAction, String)}
+     */
+    public String getURL(String action, String querystring)
+    {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getURL(documentAction, querystring);
+    }    
 
     /**
      * return the full URL of the document
      */
     public String getExternalURL()
     {
-        return doc.getExternalURL("view", getXWikiContext());
+        return doc.getExternalURL(DocumentAction.VIEW, getXWikiContext());
     }
 
     /**
-     * return the full URL of the document for the given action
+     * @see Document#getExternalURL(DocumentAction)
+     * @deprecated use {@link Document#getExternalURL(DocumentAction)} 
      */
     public String getExternalURL(String action)
     {
+        return doc.getExternalURL(DocumentAction.valueOf(action), getXWikiContext());
+    }
+    
+    /**
+     * @param action
+     * @return the full URL of the document for the given action
+     */
+    public String getExternalURL(DocumentAction action)
+    {
         return doc.getExternalURL(action, getXWikiContext());
     }
 
+    /**
+     * @deprecated use {@link Document#getExternalURL(DocumentAction, String)} 
+     */
     public String getExternalURL(String action, String querystring)
     {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getExternalURL(documentAction, querystring);
+    }
+    
+    public String getExternalURL(DocumentAction action, String querystring)
+    {
         return doc.getExternalURL(action, querystring, getXWikiContext());
-    }
+    } 
 
     public String getParentURL() throws XWikiException
     {
@@ -1135,17 +1195,37 @@
         return doc.getLastChanges(getXWikiContext());
     }
 
-    public DocumentStats getCurrentMonthPageStats(String action)
+    public DocumentStats getCurrentMonthPageStats(DocumentAction action)
     {
         return getXWikiContext().getWiki().getStatsService(getXWikiContext())
             .getDocMonthStats(doc.getFullName(), action, new Date(), getXWikiContext());
     }
+    
+    /**
+     * @see Document#getCurrentMonthPageStats(DocumentAction)
+     * @deprecated use {@link Document#getCurrentMonthPageStats(DocumentAction)}
+     */
+    public DocumentStats getCurrentMonthPageStats(String action)
+    {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getCurrentMonthPageStats(documentAction);
+    }
 
-    public DocumentStats getCurrentMonthWebStats(String action)
+    public DocumentStats getCurrentMonthWebStats(DocumentAction action)
     {
         return getXWikiContext().getWiki().getStatsService(getXWikiContext())
             .getDocMonthStats(doc.getSpace(), action, new Date(), getXWikiContext());
     }
+    
+    /**
+     * @see Document#getCurrentMonthWebStats(DocumentAction)
+     * @deprecated use {@link Document#getCurrentMonthWebStats(DocumentAction)} 
+     */
+    public DocumentStats getCurrentMonthWebStats(String action)
+    {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getCurrentMonthWebStats(documentAction);
+    }
 
     public List getCurrentMonthRefStats() throws XWikiException
     {
@@ -1153,27 +1233,48 @@
             .getRefMonthStats(doc.getFullName(), new Date(), getXWikiContext());
     }
 
+    /**
+     * @deprecated use {@link Document#checkAccess(DocumentAction)}
+     * @param right
+     * @return
+     */
     public boolean checkAccess(String right)
     {
+        DocumentAction docAction = DocumentAction.valueOf(right);
+        return this.checkAccess(docAction);
+    }
+    
+    public boolean checkAccess(DocumentAction action)
+    {
         try {
-            return getXWikiContext().getWiki().checkAccess(right, getDoc(), getXWikiContext());
+            return getXWikiContext().getWiki().checkAccess(action, getDoc(), getXWikiContext());
         } catch (XWikiException e) {
             return false;
         }
     }
-
-    public boolean hasAccessLevel(String level)
+    
+    public boolean hasAccessLevel(AccessLevel level) 
     {
         try {
             return getXWikiContext().getWiki().getRightService().hasAccessLevel(level,
                 getXWikiContext().getUser(), getDoc().getFullName(), getXWikiContext());
         } catch (Exception e) {
             return false;
-        }
+        }        
     }
 
-    public boolean hasAccessLevel(String level, String user)
+    /**
+     * @see Document#hasAccessLevel(AccessLevel)
+     * @deprecated use {@link Document#hasAccessLevel(AccessLevel)} 
+     */
+    public boolean hasAccessLevel(String level)
     {
+        AccessLevel accessLevel = AccessLevel.valueOf(level);
+        return this.hasAccessLevel(accessLevel);
+    }
+    
+    public boolean hasAccessLevel(AccessLevel level, String user)
+    {
         try {
             return getXWikiContext().getWiki().getRightService()
                 .hasAccessLevel(level, user, doc.getFullName(), getXWikiContext());
@@ -1182,6 +1283,16 @@
         }
     }
 
+    /**
+     * @see Document#hasAccessLevel(AccessLevel, String)
+     * @deprecated use {@link Document#hasAccessLevel(AccessLevel, String)}
+     */
+    public boolean hasAccessLevel(String level, String user)
+    {
+        AccessLevel accessLevel = AccessLevel.valueOf(level);
+        return this.hasAccessLevel(accessLevel, user);
+    }
+
     public boolean getLocked()
     {
         try {
@@ -1326,15 +1437,31 @@
         return doc.getDefaultEditURL(getXWikiContext());
     }
 
+    /**
+     * @deprecated use {@link Document#getEditURL(DocumentAction, String)}
+     */
     public String getEditURL(String action, String mode) throws XWikiException
     {
+        return doc.getEditURL(DocumentAction.valueOf(action), mode, getXWikiContext());
+    }
+    
+    public String getEditURL(DocumentAction action, String mode) throws XWikiException
+    {
         return doc.getEditURL(action, mode, getXWikiContext());
-    }
+    }    
 
+    /**
+     * @deprecated use {@link Document#getEditURL(DocumentAction, String, String)} 
+     */
     public String getEditURL(String action, String mode, String language)
     {
+        return doc.getEditURL(DocumentAction.valueOf(action), mode, language, getXWikiContext());
+    }
+    
+    public String getEditURL(DocumentAction action, String mode, String language)
+    {
         return doc.getEditURL(action, mode, language, getXWikiContext());
-    }
+    }    
 
     public boolean isCurrentUserCreator()
     {
Index: src/main/java/com/xpn/xwiki/api/Context.java
===================================================================
--- src/main/java/com/xpn/xwiki/api/Context.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/api/Context.java	(working copy)
@@ -104,9 +104,17 @@
 
     /**
      * @return the requested action
+     * @deprecated use {@link Context#getDocumentAction()}  
      */
     public String getAction()
     {
+        return this.getDocumentAction().toString();
+    }
+    
+    /**
+     * @return the requested action, as a {@link DocumentAction} constant.
+     */
+    public DocumentAction getDocumentAction() {
         return getXWikiContext().getAction();
     }
 
@@ -235,21 +243,38 @@
         getXWikiContext().setCacheDuration(duration);
     }
 
-    public void setLinksAction(String action)
+    public void setLinksAction(DocumentAction action)
     {
         getXWikiContext().setLinksAction(action);
     }
+    
+    /**
+     * @see Context#setLinksAction(DocumentAction)
+     * @deprecated use {@link Context#setLinksAction(DocumentAction)}
+     */
+    public void setLinksAction(String action)
+    {
+        this.setLinksAction(DocumentAction.valueOf(action));
+    }    
 
     public void unsetLinksAction()
     {
         getXWikiContext().unsetLinksAction();
     }
 
+    /**
+     * @deprecated use {@link Context#getLinksDocumentAction()}
+     */
     public String getLinksAction()
     {
-        return getXWikiContext().getLinksAction();
+        return this.getLinksDocumentAction().toString();
     }
 
+    public DocumentAction getLinksDocumentAction()
+    {
+        return getXWikiContext().getLinksAction();
+    }    
+
     public void setLinksQueryString(String value)
     {
         getXWikiContext().setLinksQueryString(value);
